#!/usr/bin/python
# -*- coding: utf-8 -*-


"""
	@Description:   This is a timer app
	@Author: 	    Zhouhan Chen
	@Last modified: 12/24/2014 Beijing Time

    Issue: When make executable file, remember to add all music and images
"""

import time
from datetime import datetime 
import datetime
import Tkinter
from Tkinter import *
import tkMessageBox as box
#import PIL
#from PIL import ImageTk, Image
import thread
import pickle
import math
import pyaudio
import numpy
import wave
import os.path
from os.path import dirname
import os 
#import test_sound 


## dd/mm/yyyy format
print (time.strftime("%H:%M:%S"))
print (time.strftime("%d/%m/%Y"))

currentSecond= datetime.datetime.now().second
currentMinute = datetime.datetime.now().minute
currentHour = datetime.datetime.now().hour

currentDay = datetime.datetime.now().day
currentMonth = datetime.datetime.now().month
currentYear = datetime.datetime.now().year

check_hour = -1
check_minute = -1



# display current time	
counter = -1
popT = False
MODE = "self"
AUTO_CREATE = False
# store seperate gif images into a list
imagelist = []



def resource_path(filename):
    #filename = 'myfilesname.type'
    if hasattr(sys, '_MEIPASS'):
        # PyInstaller >= 1.6
        os.chdir(sys._MEIPASS)
        filename = os.path.join(sys._MEIPASS, filename)
    elif '_MEIPASS2' in os.environ:
        # PyInstaller < 1.6 (tested on 1.5 only)
        chdir(os.environ['_MEIPASS2'])
        filename = os.path.join(os.environ['_MEIPASS2'], filename)    

    else: 
        os.chdir(dirname(sys.argv[0]))
        filename = os.path.join(dirname(sys.argv[0]), filename)
    return filename


for x in xrange(0,18):
    #oldfilename = "all_gifs/" +  str(x) + ".gif"
    filename = "all_gifs/"  +  str(x) + ".gif"
    #filename = resource_path('all_gifs')  + '/' + str(x) + ".gif"
    print filename
    #print filename
    imagelist.append(filename)





def counter_label(label):
  def count():

    # How to delete the window?
    # if t == 0:
    #     pass
    # else:    
    #     window_Destory(t, datetime.now().second)


    currentSecond= datetime.datetime.now().second
    currentMinute = datetime.datetime.now().minute
    currentHour = datetime.datetime.now().hour

    label.config(   text=time.strftime("%H : %M : %S"),
                    fg = "light green",
                    bg = "dark green",
                    font = "Helvetica 40 bold italic"
                )

    if counter >= 0:
        autoUpdate()
    if (popT and currentHour == int(check_hour) and currentMinute == int(check_minute)  ):
    
        t = Toplevel(root)
        t.geometry('600x550-200+100')
        exercise_word = Label(t, text = "Stand up and Exercise! \n testing",
                                 fg = "light green",
                                 bg = "dark green",
                                 font = "Helvetica 35 bold italic")
        exercise_word.pack()
        t.attributes('-topmost', 1)
        t.lift(root)

        # im = Image.open("run.jpg")

        # back_image = ImageTk.PhotoImage(im) 
        # exercise_im = Label(t, image=back_image)
        # exercise_im.image = back_image
        # exercise_im.pack(side = "bottom", fill = "both", expand = "yes") 

        #box.showinfo("Say Hello", "Hello World")
        thread.start_new_thread( play_alarm, () )
        thread.start_new_thread( window_Destory, (t, currentSecond) )


        
        global popT
        popT = False
        #destory this window after 2 seconds!
        # while ( abs(datetime.now().second - currentSecond) < 15):
        #    pass
        # t.destroy()

        #box.showwarning("Warning", "Deprecated function call")
    label.after(1000, count)

  count()

# Popup window will be automatically destoryed after 15 seconds
def window_Destory(window, oldsecond):

    photo = PhotoImage(file = imagelist[0])
    width = photo.width()
    height = photo.height()
    canvas = Canvas(window, width = width, height = height)
    canvas.pack()

    giflist = []
    for imagefile in imagelist:
        # take care of this filename
        photo = PhotoImage(file = imagefile)
        giflist.append(photo)

    try:
        while ( abs(datetime.datetime.now().second - oldsecond ) < 15):
            for gif in giflist:
                #canvas.get_tk_widget().delete("all")
                #clear the canvas first
                canvas.delete("all")
                canvas.create_image(width/2.0, height/2.0, image = gif)
                #canvas.update()
                time.sleep(0.07)
        window.destroy()
    except Exception, e:
        pass

    finally:
        pass

           

def main():
    global root
    root = Tk()
    root.title('exercise timer')
    root.wm_attributes("-topmost", 1)


    root.geometry("600x480+300+300")
    #app = Example(root)

    
    label = Label(root, text = "Program starting...", 
                        font = "Helvetica 40 bold italic",
                        relief = RAISED)
    label.pack()
    global label_mytime
    label_mytime = Label(root, text = "Please enter your exercise time", 
                               font = "Helvetica 30 bold italic",
                               relief = RAISED)
    label_mytime.pack()    

    # def evaluate(event):
    #     global hour, minute
    #     hour =  str(entry.get())
    #     minute = str(entry2.get())
    #     label_choose.configure(text = "You select " + hour +":"+ minute + "\n Is that correct?")
    #     label_choose.pack()

    topframe = Frame(root)
    topframe.pack()

    topframe_save = Frame(root)
    topframe_save.pack()


    prompt_hour = Label(root, text="Hour(24 based)")
    prompt_hour.pack()
    entry = Entry(root, bd =5, bg = "yellow", highlightcolor = "red")
    #entry.bind("<Return>", evaluate)
    entry.pack()

    prompt_hour = Label(root, text="Minute")
    prompt_hour.pack( )
    entry2 = Entry(root, bd =5, bg = "yellow", highlightcolor = "red")
    #entry2.bind("<Return>", evaluate)
    entry2.pack()




    #var = StringVar()
    #var.set("Hey! How are you?")
    #label_choose = Label(root, text = "", relief = RAISED)



    b = Button(root, text="Start/Reset", command = lambda:setup_click(label_mytime, entry.get(), entry2.get() ))
    b.pack()


    bn_quit = Button(root, text="Quit", command = root.destroy )
    bn_quit.pack()

    bt_save = Button(topframe_save, fg = "green", text="Save", state = DISABLED, command = fileSave,  relief = SUNKEN )
    bt_save.pack(side = LEFT)
    bt_load = Button(topframe_save, fg = "#01DF01", text="Load", state = DISABLED, command = fileLoad,  relief = RIDGE )
    bt_load.pack(side = LEFT)    

    CheckVar = IntVar()

    C1 = Radiobutton(topframe, text = "Auto select", variable = CheckVar, 
                     value = 1, height=2, command = lambda:autoSelect(entry, entry2, b, bt_save, bt_load), 
                     width = 15)
    C2 = Radiobutton(topframe, text = "Self select", variable = CheckVar,
                     value = 2, height=2, command = lambda:selfSelect(entry, entry2, b, bt_save, bt_load), 
                     width = 15)
    C1.pack(side = LEFT)
    C2.pack(side = LEFT)
    CheckVar.set(2)

    counter_label(label)
    root.mainloop()  


def autoSelect(mes1, mes2, b, save, load):
    mes1.config( state = DISABLED)
    mes2.config( state = DISABLED)
    save.config( state = NORMAL)
    load.config( state = NORMAL)
    global MODE
    MODE = "auto"
    #b.config(state = DISABLED)
    if AUTO_CREATE:
        for i in auto_data_container:
            i.config(state = NORMAL )

    else:    
        # update auto selected check_hour and check_minute
        # add a bottom frame that contains a scale bar
        bottomframe = Frame(root)
        bottomframe.pack()
        # add three different scales
        # choose start hour
        start_hour_label = Label(bottomframe, text="Select start time(hour)", #bg = "#adda55", 
                                 font = "Helvetica 16 bold")
        start_hour_label.pack(side = LEFT, anchor = S)

        start_hour_var = IntVar()
        start_hour = Scale( bottomframe, variable = start_hour_var, orient=HORIZONTAL, 
                            resolution = 1, from_ = 1, to = 24,
                            sliderlength = 30, length = 300)
        start_hour.pack(side = LEFT, anchor = CENTER)

        #choose end hour
        bottomframe2 = Frame(root)
        bottomframe2.pack()
        end_hour_label = Label(bottomframe2, text="Select end time (hour)", #bg = "#adda55", 
                                 font = "Helvetica 16 bold")
        end_hour_label.pack(side = LEFT, anchor = S)

        end_hour_var = IntVar()
        end_hour = Scale( bottomframe2, variable = end_hour_var, orient=HORIZONTAL, 
                        resolution = 1, from_ = 1, to = 24,
                        sliderlength = 30, length = 300)
        end_hour.pack(side = LEFT , anchor = CENTER)    

        # choose interval
        bottomframe3 = Frame(root)
        bottomframe3.pack()
        start_hour_label = Label(bottomframe3, text="Select an interval(min)", #bg = "#adda55", 
                                 font = "Helvetica 16 bold")
        start_hour_label.pack(side = LEFT, anchor = S)

        scale_interval_var = IntVar()
        scale_interval = Scale( bottomframe3, variable = scale_interval_var, orient=HORIZONTAL, 
                                resolution = 1, from_ = 1, to = 59,
                                sliderlength = 30, length = 300)
        scale_interval.pack(side = LEFT, anchor = CENTER)    
        global auto_data_container, AUTO_CREATE
        AUTO_CREATE = True
        #auto_data_container = [start_hour_var.get(), end_hour_var.get() ,scale_interval_var.get()]
        auto_data_container = [start_hour, end_hour,scale_interval]



def fileSave():
    # change animal, population
    prompt = ""
    if 'time_interval' in globals() and len(time_interval) > 0:
        with open('user_info.pik', 'wb') as f:
            pickle.dump( time_interval , f, -1)
        box.showinfo("Save Status", "Saved successfully", parent = root)    
        prompt = "Saved successfully"
    
    else:
        prompt = "Could not save, check your input \n and click 'start' first"         
        box.showwarning("Save Status", prompt, parent = root)    


    
    
def fileLoad():
    if os.path.isfile('user_info.pik'):
        with open('user_info.pik', 'rb') as f:
            global time_interval
            time_interval = pickle.load(f)
        global counter, popT
        popT = False
        counter = 0
    
    else:
        box.showwarning("Load Status", "Could not load, no file exists", parent = root)  

       


def selfSelect(mes1, mes2, b, save, load):
    mes1.config(state = NORMAL)
    mes2.config(state = NORMAL)
    b.config(state = NORMAL)
    save.config( state = DISABLED)
    load.config( state = DISABLED)

    global MODE
    MODE = "self"
    global counter
    counter = -1
    if AUTO_CREATE:
        for i in auto_data_container:
            i.config(state = DISABLED )


def setup_click(label2, hour, minute):


    if (MODE == "self"):

        global check_hour
        global check_minute
        check_hour = hour
        check_minute = minute


        try:
            check_hour = int(check_hour)
            check_minute = int(check_minute)
            global popT
            popT = True
            if int(minute) < 10 and len(minute) <= 1:
                minute = "0" + minute
            label2.config(   text = hour + " : " + minute  + " : 00",
                fg = "light green",
                bg = "red",
                font = "Helvetica 40 bold italic"
            )
        except Exception, e:

            label2.config(   text = "Invalid input, please try again",
                fg = "red",
                bg = "light green",
                font = "Helvetica 34 bold italic"
            )        

    elif (MODE == "auto"):
        
        #calculate all time intervals
        start = auto_data_container[0].get()
        end = auto_data_container[1].get()
        interval = auto_data_container[2].get()

        a = datetime.datetime(100,1,1,start,00,00)
        intv = datetime.timedelta(minutes = interval)

        #b = a + intv
        global time_interval
        time_interval = []
        upperbound = int (round( (end - start) * 60 / interval ) ) + 1
        for x in xrange(1,upperbound):
            b = a + intv
            if b.hour < end:
                time_interval.append(  (b.hour, b.minute) )
            a = b
        global counter, popT
        popT = False
        counter = 0
        if len(time_interval) <= 0:
            label_mytime.config(text = "Invalid input",
                    fg = "light green",
                    bg = "red",
                    font = "Helvetica 40 bold italic"
                    )

def autoUpdate():

    global counter, check_hour, check_minute

    if not popT and counter < len(time_interval):
        auto_data_container[0].set(time_interval[0][0])
        auto_data_container[1].set(time_interval[-1][0] + 1)
        auto_data_container[2].set(time_interval[0][1])


        check_hour = time_interval[counter][0]
        check_minute = time_interval[counter][1]            
        global popT
        popT = True
        counter += 1
        min_str = str(check_minute)
        if check_minute < 10:
            min_str = "0" + min_str
        prompt = str(check_hour) + " : " + min_str  + " : 00"
        label_mytime.config(text = prompt,
                            fg = "light green",
                            bg = "red",
                            font = "Helvetica 40 bold italic"
                            )
    elif counter >= len(time_interval):
        prompt = "Auto select stops"
        label_mytime.config(text = prompt,
                            fg = "light green",
                            bg = "red",
                            font = "Helvetica 40 bold italic"
                            )



def play_alarm():


    # chunk = 1024
    # # choose an appropriate background music
    # # back_music_short.wav benpao.wav
    # print resource_path("nufang.wav")
    # #wf = wave.open( resource_path('nufang.wav'), 'rb')
    # wf = wave.open( "nufang.wav", 'rb')
    # p = pyaudio.PyAudio()

    # stream = p.open(
    #     format = p.get_format_from_width(wf.getsampwidth()),
    #     channels = wf.getnchannels(),
    #     rate = wf.getframerate(),
    #     output = True)
    # data = wf.readframes(chunk)

    # while data != '':
    #     stream.write(data)
    #     data = wf.readframes(chunk)

    # stream.close()
    # p.terminate()
    os.system("afplay nufang.wav")





if __name__ == '__main__':
    #thread.start_new_thread( main, () )
    main()  

